//
//  CRBackgroundProvider.h
//  CRGraphics
//
//  Created by Yaroslav Glushchenko on 4/7/10.
//  Copyright 2010 Corner-A. All rights reserved.
//


//////////////////////////////////////////////////////////////////////
// Base background provider
//////////////////////////////////////////////////////////////////////
@interface CRBackgroundProvider : NSObject<CREditing>
{
}

+ (id)background;

- (CIImage *)imageOfSize:(CGSize)size;		// output image of the given size
- (CIImage *)thumbnailOfSize:(CGSize)size;	// 256x256 output image scaled to size (better than outputImage for icons and thumbnails)

- (NSString *)title;
- (BOOL)providesView;
- (Class)viewControllerClass;
- (NSViewController *)viewController;

@end